/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.nyms.httpodesilac.gui;

import cz.nyms.httpodesilac.Option;
import cz.nyms.httpodesilac.netcore.NetCore;
import cz.nyms.httpodesilac.UserCl;
import cz.nyms.httpodesilac.netcore.UploadThread;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.io.File;
import java.util.LinkedList;
import javax.swing.BoxLayout;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

/**
 *
 * @author jirka
 */
public class FileForm extends JPanel {

  /*new folder
   * hash, entityType, classroomId, newFolder, 
   * */
  static String galTmplURL = "http://www.spoluzaci.cz/photoScreen?classroomId=";
  protected Container top = new Container(),  bottom = new Container();
  public String classId;
  protected UserCl u;
  JComboBox cbFolders = new JComboBox();
  public boolean init = false;
  private File[] files;
  LinkedList<ImageItem> items = new LinkedList<ImageItem>();
  private JScrollPane sc = new JScrollPane();
  JPanel images = new JPanel();
  Integer width;
  JButton btnSend = new JButton("Odeslat"), btnSendSmall = new JButton("Odeslat jen malé soubory");
  JTextField tfNewFolder = new JTextField();
  JButton btnReset = new JButton("Zrušit");
  NetCore nc;
private LinkedList<File> delete=new LinkedList<File>();


/**
 * Metoda pro odstaranění vygenerovaných náhledů
 */
  public void deleteThumbs() {
    for (File f: delete){
      System.out.println("delete"+f.getAbsolutePath());
      f.delete();
      
    }
    delete.clear();
  }
  /**
   * Před odeslání zakáže klikat na tlačítka, po odeslání to opět povolí
   */
  public void enableButtons(boolean e) {
    btnReset.setEnabled(e);
    btnSend.setEnabled(e);
    btnSendSmall.setEnabled(e);
  }

  /**
   * odstraní položku z formuláře
   * @param item položka, kterou chceme odstranit
   */
  public void removeItem(ImageItem item) {

    images.remove(item);
    images.setVisible(false);
    images.setVisible(true);
  //throw new UnsupportedOperationException("Not yet implemented");
  }

  /**
   * Načte soubory
   * @param files
   */
  public void setFiles(File[] files) {
    this.files = files;
    for (int i = 0; i < items.size(); i++) {
      items.remove();
    }
    images.removeAll();
    images = new JPanel();
    images.setVisible(false);
    images.setVisible(true);

  }

  /**
   * Kostruktor, naaranžuje prvky do formuláře
   * @param nc NetClient
   * @param u
   */
  public FileForm(NetCore nc, UserCl u) {
    super();
    this.nc = nc;
    classId = u.getClassId();
    setLayout(new BorderLayout());
    top.setLayout(new FlowLayout(FlowLayout.LEFT));
    top.add(new JLabel("Složka: "));
    this.u = u;

    LinkedList<Option> folders = nc.getGalleryList(galTmplURL + u.getClassId());
    //System.out.println(nc.formFolderList);
    cbFolders.setModel(new DefaultComboBoxModel(folders.toArray()));
    top.add(cbFolders);
    top.add(new JLabel("  Nová:"));

    top.add(tfNewFolder);
    JButton btnCreate = new JButton("Vytvořit");
    top.add(btnCreate);

    top.add(btnReset);
    add(top, BorderLayout.NORTH);

    sc.setViewportView(images);

    add(sc, BorderLayout.CENTER);
    images.setLayout(new BoxLayout(images, BoxLayout.Y_AXIS));

    bottom.setLayout(new BoxLayout(bottom, BoxLayout.X_AXIS));
    bottom.add(btnSend);
    bottom.add(btnSendSmall);
    bottom.add(btnReset);
    add(bottom, BorderLayout.SOUTH);
    top.repaint();
    top.setVisible(true);
    tfNewFolder.setColumns(12);
    setVisible(true);
    btnReset.setVisible(false);
    /*
    btnReset.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(ActionEvent ev) {
    deleteAllItems();
    }
    });
     */
    //Na serveru vytvoří danou složku
    btnCreate.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent arg0) {
        createFolder();
      }
    });

    btnSendSmall.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent arg0) {
        sendSmall();
      }
    });
    btnSend.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent arg0) {
        sendAll();
      }
    });
  }

  /**
   * Odešle včechny soubory, u velkých, které jsou zaškrtnuty nabídne zmenšení
   */
  private void sendAll() {
    DlgResizeImage dlg = new DlgResizeImage();

    LinkedList<ImageItem> all = new LinkedList<ImageItem>();
    
    for (ImageItem i : items) {
      if (i.isSmall()) {
        all.add(i);
      } else if(i.chbResize.isSelected()) {
        dlg.changeFile(i.getFile());
        dlg.showDialog();
        if (dlg.getStatus()==DlgResizeImage.OK){  //projistotu
          System.out.println("abc-"+dlg.getNewImage().getAbsolutePath());
          i.setFile(dlg.getNewImage());
          all.add(i);
          delete.add(dlg.getNewImage());
        }
      }
    }
    if (all.size() > 0) {
      enableButtons(false);
    
    UploadThread ut = new UploadThread(nc, all, this);
    ut.run();
    items.clear();
    }
  }

  /*Nefunguje*
   * Z formuláře smaže všechny položky
   */
  /*private void deleteAllItems(){
  for (ImageItem i: items){
  remove(i);
  items.remove(i);
  }
  setVisible(false);
  setVisible(true);
  }
   */
  /**
   * Vytvoří novou složku na serveru
   */
  private void createFolder() {

    nc.createFolder(tfNewFolder.getText());
    DefaultComboBoxModel cmb = new DefaultComboBoxModel(nc.getGalleryList(
            galTmplURL + u.getClassId()).toArray());
    cbFolders.setModel(cmb);
    tfNewFolder.setText("");
  }

  /**
   * Odešle pouze malé soubory
   */
  private void sendSmall() {

    LinkedList<ImageItem> small = new LinkedList<ImageItem>();
    for (ImageItem i : items) {
      if (i.isSmall()) {
        small.add(i);
      }
    }
    if (small.size() > 0) {
      enableButtons(false);
    
    UploadThread ut = new UploadThread(nc, small, this);
    ut.run();
    }
items.clear();
  }

  /**
   * 
   * @return "číslo" zvolené třídy
   */
  public String getSelectedFolderId() {
    return ((Option) cbFolders.getSelectedItem()).getValue();
  }

  /**
   * Načte soubory získané z dialogu a do formuláře přidá položky, které je reprezentují
   * @param files pole souborů
   */
  void loadImages(File[] files) {
    ImageItem i;

    for (File f : files) {

      width = getWidth();
      i = new ImageItem(f, this);

      items.add(i);
      images.add(i);

    }
    images.setVisible(false);
    images.setVisible(true);


  }
}
