/*    
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.nyms.httpodesilac.gui;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.io.File;
import javax.swing.Box;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JTextField;
import javax.swing.BoxLayout;

/**
 * Kontejner obsahující jméno obrázku, pole pro jeho popisek atd
 * @author jirka
 */
public class ImageItem extends Container {

  static int count = 0;
  public JLabel lblName,  lblSize;
  public JLabel lblPopis = new JLabel("Popis obrázku");
  public JTextField tfPopis = new JTextField();
  public JCheckBox chbResize = new JCheckBox("Zmenšit");
  private long fileSize;
  private boolean sizeOK = false;
  JButton btnDelete = new JButton("Odebrat");
  private Container center = new Container(),  east = new Container();
  int width, height;
  double ratio;
  Color bgColor;
  public int n;
  FileForm parrent;
  ImageItem self;

  /**
   * 
   * @return Soubor s obrázkem
   */
  public File getFile() {
    return file;
  }
  private File file;
  /**
   * 
   * @return Popis obrázku
   */
  public String getPopis() {
    return tfPopis.getText();
  }

  /**
   * Konstruktor
   * @param file
   * @param parrent
   */
  public ImageItem(File file, FileForm parrent) {
    super();
    this.file=file;
    self = this;
    this.parrent = parrent;
    count++;

    this.setLayout(new BorderLayout(5, 10));
    lblName = new JLabel(file.getName());
    lblSize = new JLabel(" - " + file.length() + " Bytů");

    //System.out.println(file.length());
    fileSize = file.length();
    //nebudu riskovat
    if (fileSize < 512000) {
      sizeOK = true;
    } else {
      chbResize.setSelected(true);
    }
    chbResize.setVisible(!sizeOK);
    chbResize.setEnabled(false);
    //ok, uz to je strasny, ale grid/gridbag layout se mi vytvarel blbe
    center.setLayout(new BorderLayout());
    Container centerTop = new Container();
    Container centerBottom = new Container();
    center.add(centerTop, BorderLayout.NORTH);
    centerBottom.setBackground(bgColor);
    centerTop.setBackground(bgColor);

    centerTop.setLayout(new FlowLayout(FlowLayout.LEFT));
    centerTop.add(lblName);
    centerTop.add(lblSize);
    center.add(centerBottom, BorderLayout.SOUTH);

    centerBottom.setLayout(new FlowLayout(FlowLayout.LEFT));
    tfPopis.setColumns(32);
    centerBottom.add(new JLabel("Popis: "));
    centerBottom.add(tfPopis);
    add(center, BorderLayout.CENTER);
    add(Box.createRigidArea(new Dimension(0, 5)), BorderLayout.SOUTH);
    //chbResize.setText("zkouška");
    east.setLayout(new BoxLayout(east, BoxLayout.Y_AXIS));

    east.add(btnDelete);
    east.add(chbResize);
    add(east, BorderLayout.EAST);
    btnDelete.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent arg0) {
        //tak na tohle jsem zvedavej
        delete();
      }
    });

    setVisible(true);
  }
  
/**
 * 
 * @param file Nový zmenšený obrázek
 */
  public void setFile(File file) {
    this.file = file;
  }
  
  /**
   * 
   * @return True, pokud je soubor menší jak 512KB
   */
  public boolean isSmall(){
    return sizeOK;
  }
  
  /**
   * Smaže položku z formuláře
   */
  private void delete(){
    parrent.images.remove(self);
    parrent.items.remove(self);
    parrent.setVisible(false);
    parrent.setVisible(true);
  }
  
}
