/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.nyms.httpodesilac.gui;

import cz.nyms.httpodesilac.Config;
import cz.nyms.httpodesilac.Option;
import cz.nyms.httpodesilac.User;
import java.awt.Container;
import java.awt.event.ActionEvent;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

/**
 * Kontejner s formulářem pro přihlášení k serveru
 * @author jirka
 */
public class Login extends Container {

  //String[] servery;
  JLabel lblUsername = new JLabel("Uživatelské jméno");
  JLabel lblPasswd = new JLabel("Heslo:");
  JLabel lblServer = new JLabel("@");
  JPasswordField password;
  JTextField username;
  JButton btnLogin = new JButton("Přihlásit se");
  JComboBox server = new JComboBox();
  JLabel lblMsg = new JLabel("");
  String url = "http://login.seznam.cz/?username=&lang=cz&returnURL=&remember=&loggedURL=http%3A%2F%2Fwww.spoluzaci.cz%2FticketProcess%3Furi%3D%252F&forceSSL=0&relogin=0&serviceId=spoluzaci&sDomain=0&template=html&disableSSL=0&serviceDisabled=0&set_disableSSL=1";
  Container top;
  private Config cfg;

  /**
   * Konstruktor
   * @param dcm seznam serverů seznamu
   */
  public Login(DefaultComboBoxModel dcm) {
    super();
    cfg = new Config();//("/home/jirka/spoluzaci.conf");
    User user = cfg.getUser();
    //setLayout(new FlowLayout());
    setLayout(null);
    //setBounds(0,0, top.getWidth(), 100);
    server.setModel(dcm);

    username = new JTextField(user.getName());
    password = new JPasswordField(user.getPassword());

    add(lblPasswd);
    lblPasswd.setBounds(8, 24, 120, 20);
    add(password);
    password.setBounds(128, 24, 128, 20);


    add(lblUsername);
    lblUsername.setBounds(8, 4, 120, 20);
    add(username);
    username.setBounds(128, 4, 128, 20);
    //add(lblServer);
    Option o;
    for (int i = 0; i < server.getItemCount(); i++) {
      o = (Option) server.getItemAt(i);
      if (o.getValue().equals(user.getDomain())) {
        server.setSelectedIndex(i);
        break;
      }
    }
    add(server);
    server.setBounds(256, 4, 128, 20);

    add(btnLogin);
    btnLogin.setBounds(64, 48, 128, 20);
    setVisible(true);

    add(lblMsg);
    lblMsg.setBounds(8, 72, 256, 24);
    JButton btnSave = new JButton("Uložit nastavení");
    btnSave.setToolTipText("Uloží pouze uživatelské jméno a server");
    add(btnSave);
    btnSave.setBounds(196, 48, 128, 20);
    btnSave.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent arg0) {
        save();
      }
    });
  }

  /**
   * Uloží obsah polí se jménem uživatele a adresou serveru
   */
  private void save() {
    cfg.setName(username.getText());
    cfg.setServer(((Option) server.getSelectedItem()).getValue());
    cfg.save();

  }
}
