/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.nyms.httpodesilac.netcore;

import cz.nyms.httpodesilac.Option;
import java.io.InputStream;
import org.apache.commons.httpclient.Header;
import org.apache.commons.httpclient.NameValuePair;
import org.apache.commons.httpclient.methods.PostMethod;
import cz.nyms.httpodesilac.User;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.regex.Pattern;

/**
 * Třída, která se k serveru přihlašuje přes HTTP protokol, implementace
 * přihlášení přes HTTPS zatím nebudu řešit
 * @author jirka
 */
public class HttpCore extends NetCore {

  
  public HttpCore(User user) {
    super(user);
  }

  public HttpCore() {
    super();
  }

  /**
   * Metroda, ktera zajisti prihlaseni k serveru spoluzaci.cz
   * @return Pokud bylo přihlášení úspěěné, pak true, jinak false
   */
  @Override
  public boolean login() {
    int status = 302;

    String redirectLocation = null;
    try {
//post=new PostMethod();
        post = new PostMethod("http://login.szn.cz/loginProcess");
      //client.setState(initialState);
      //post = new PostMethod();

      //Tohle by šlo získat automaticky z kódu, nějaký ten regexp... neni ale cas
      NameValuePair[] data = {
        new NameValuePair("username", user.getName()),
        new NameValuePair("password", user.getPassword()),
        new NameValuePair("domain", user.getDomain()),
        new NameValuePair("serviceId", "spoluzaci"),
        new NameValuePair("disableSSL", "1"),
        new NameValuePair("forceSSL", "0"),
        new NameValuePair("lang", "cz"),
        new NameValuePair("loginType", "seznam"),
        //new NameValuePair("loggedURL", "http://www.spoluzaci.cz/ticketProcess?uri=%2F"),
        new NameValuePair("returnURL", "http://www.spoluzaci.cz/sessionProcess?uri=%2F"),
        new NameValuePair("forceRelogin","0"),
        new NameValuePair("coid",""),
                
        new NameValuePair("loginFormIsSSL", "0")
      };

      post.setRequestBody(data);
      //tady se odeslou data pro prihlaseni
      status = client.executeMethod(post);

      Header locationHeader = post.getResponseHeader("location");
      if (locationHeader != null) {
        redirectLocation = locationHeader.getValue();
      } else {

        InputStream pst = post.getResponseBodyAsStream();
        BufferedReader br = new BufferedReader(new InputStreamReader(pst,"utf8"));
        String line;
        String url = "";
        p = Pattern.compile("url=(.+)\">");
        
        while ((line = br.readLine()) != null) {
          m = p.matcher(line);
          if (m.find()) {
            url = m.group(1);
            url = url.replace("&amp;", "&");
          }

        }
        br.close();

        redirectLocation = url;
      }

    } catch (IOException ex){
      System.err.print("def");
      post.releaseConnection();
      get.releaseConnection();

    } catch (Exception ex) {
      System.out.println(post.getName());
      System.err.print("abc - ");
      System.err.println(ex.getMessage());
      post.releaseConnection();
      get.releaseConnection();

    }    //přesměrujeme se znova
    
    
    //jsme presmerovani
    String line;
    tridy = new LinkedList();

    while (redirectLocation != null && status != 302) {
      try {
        
        BufferedReader br = new BufferedReader(new InputStreamReader(pageStream(redirectLocation),"utf8"));
        //InputStream pst = post.getResponseBodyAsStream();
        //BufferedReader br = new BufferedReader(new InputStreamReader(pst,"utf8"));
        //String line;
        String url = "";
        p = Pattern.compile("url=(.+)\">");
        
        while ((line = br.readLine()) != null) {
          m = p.matcher(line);
          if (m.find()) {
            url = m.group(1);
            url = url.replace("&amp;", "&");
          }

        }
        br.close();
        redirectLocation = url;        
        
        br = new BufferedReader(new InputStreamReader(pageStream(redirectLocation),"utf8"));
        // http://www.spoluzaci.cz/classroomScreen?classroomId=310251
        //dalsi conscriptovo "kouzlo":-), bez nej by to vypadalo hur a 
        p = Pattern.compile("<a href=\"[^?]+\\?classroomId=([0-9]+)\">([^(]*)\\(([0-9]+)\\)\\s-\\s([^-<]+)");
        //Matcher m;
        while ((line = br.readLine()) != null) {
          //System.out.println(line);
          m = p.matcher(line);
          while (m.find()) {
            String str=m.group(2)+" ("+m.group(3)+") - "+m.group(4);
            tridy.add(new Option(str, m.group(1) ));
          }
        }
      } catch (Exception ex) {
        System.err.println("chyba");
        System.err.println(ex.getMessage());
      } finally {
        get.releaseConnection();
        //System.out.println(status);
        if (status != 302) {
          return true;
        }
      }
    }
    return false;
    
  }
}
