/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.nyms.httpodesilac.netcore;

import cz.nyms.httpodesilac.gui.FileForm;
import cz.nyms.httpodesilac.gui.ImageItem;
import java.util.LinkedList;

/**
 * Vlakno, ktere odesila data na server
 * @author jirka
 */
public class UploadThread extends Thread {
  private NetCore nc;
  private LinkedList<ImageItem> items;
  private FileForm parent;

  /**
   * 
   * @param nc Jádro pro práci se sítí
   * @param items Polozky, ktere se budou uploadovat
   */
  public UploadThread(NetCore nc, LinkedList<ImageItem> items, FileForm parent){
    this.nc=nc;
    this.items=items;
    this.parent=parent;
  }

  /**
   * Metoda zajišťující odeslání souborů
   */
  @Override
  public void run(){
    ImageItem item;
    while(items.size()>0){
      item=items.pop();
      nc.sendFile(item, parent.getSelectedFolderId());
      parent.removeItem(item);
    }
    parent.enableButtons(true);
    parent.deleteThumbs();
    nc.close();
  }
  
  
}
