/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.nyms.httpodesilac;

/**
 * Třída rozšiřující třídu User o číslo třídy
 * @author jirka
 */
public class UserCl extends User {
  protected String classId;

  /**
   * 
   * @return "číslo" třídy
   */
  public String getClassId() {
    return classId;
  }

  /**
   * Konstruktor 
   * @param name uživatelské jméno
   * @param passwd heslo
   * @param domain doména seznamu
   * @param classId číslo třídy
   */
  public UserCl(String name, String passwd, String domain, String classId) {
    super(name, passwd, domain);
    this.classId = classId;
  }

  /**
   * Konverzní konstruktor
   * @param u Původní uživatel
   * @param classId číslo třídy
   */
  public UserCl(User u, String classId) {
    super(u.getName(), u.getPassword(), u.getDomain());
    this.classId = classId;
  }
}
